//===========================
void serialEvent()
{}        
//===========================
char read(void)
{ if(prog_run==0)      return(Serial.read() );
  else 
  {
    if(prog_run==1)           c=EEPROM.read(prog_n*256+prog_ptr++);
    else /*if(prog_run==2)*/  c=myFile.read();
    if(c=='_')
    {
      Serial.print("Prog[");           Serial.print(prog_n);
      Serial.println("]EndRun");
      if(stack>0)
      {  
          stack--;
          prog_n=stack_n[stack];
          prog_ptr=stack_ptr[stack];
          prog_run=stack_run[stack];
          if(prog_run==2)
          {
           Serial.println("========");
           f_n[0]='0'+prog_n/100000%10;
           f_n[1]='0'+prog_n/10000%10;
           f_n[2]='0'+prog_n/1000%10;
           f_n[3]='0'+prog_n/100%10;
           f_n[4]='0'+prog_n/10%10;
           f_n[5]='0'+prog_n%10;
           myFile=SD.open(f_n);
           Serial.println(f_n);
           myFile.seek(prog_ptr);
          }
          Serial.print("stack=");     Serial.println(stack);
          Serial.print("prog_ptr=");   Serial.println(prog_ptr);
          Serial.print("prog_run=");   Serial.println(prog_run);
          Serial.print("prog_n=");     Serial.println(prog_n);
      }
      else prog_run=0;
    }
    return(c);
  }
}
//===========================
char peek(void)
{ if(prog_run==0) return(Serial.peek() );
  else if(prog_run==1)
  { c=EEPROM.read(prog_n*256+prog_ptr);
          //Serial.print("peek prog_ptr=");Serial.print(prog_ptr);
          //Serial.print(" c=");           Serial.println(c);
    return(c);
  }
  else  return(myFile.peek() );
}
//===========================
uint16_t available(void)
{ if(prog_run==0)
  return(Serial.available() );
  else if(prog_run==1)
  { 
          //Serial.print("available prog_ptr=");
          //Serial.println(prog_ptr);
    
    if( (prog_ptr>0)&&(EEPROM.read(prog_n*256+prog_ptr-1)=='_') )
    return(0);
    else
    return(1);
  }
  else return(myFile.available() );
}
//===========================
void read_command()
{ if (available()>0) 
  { if(comm_n==0)
    { comm_char=read();
      if((comm_char>='A')&&(comm_char<='z'))
      { comm=comm_char;
        comm_n=1;comm_zn=1;comm_dig=0;
        comm_d[0]=-1999999999;comm_d[1]=-1999999999;comm_d[2]=-1999999999;
        comm_d[3]=-1999999999;comm_d[4]=-1999999999;//comm_d[5]=-1999999999;
      }
    }
    else if((comm_n>0)&&(comm_n<7))
    {
      comm_char=peek();
      if((comm_char==10)||(comm_char=='_')||((comm_char>='A')&&(comm_char<='z')))
      { comm_n=7;}
      else if(comm_char=='-'){comm_char=read();comm_zn=-1;}
      else if((comm_char>='0')&&(comm_char<='9'))
      { comm_char=read();
        comm_dig=comm_dig*10+(comm_char-'0');
        if(comm_n<7){comm_d[comm_n-1]=comm_zn*comm_dig;}
      }  
      else comm_char=read();
      if(comm_char==';'){comm_n++;comm_zn=1;comm_dig=0;}
    }
    else if(comm_n==7)
    { comm_n=8;
      if(comm!='_') ExecCommand();
      else comm_n=0; 
    }
  }    
}
//=============================
void ExecCommand1(void)
{ 
      if((comm=='G')||(comm=='g'))
      { if (comm=='G')
        { txx=V_max[0];tyy=V_max[1];tzz=V_max[2];
          tee=V_max[3];tqq=V_max[4];}
        else
        { txx=v_max[0];tyy=v_max[1];tzz=v_max[2];
          tee=v_max[3];tqq=v_max[4];}

        for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { pos_set[i]+=comm_d[i]*mx[i];
          Serial.print("pos_set[");  Serial.print(axis_name[i]);
          Serial.print("]=");        Serial.println(pos_set[i]);
        }
        Go();
                  //===================
                  //tim2=tim0;
                  //Serial.print("ExecCommand=");
                  //Serial.println(tim2-tim1);
                  tim1=tim2;
                  //===================
        
        menu_redraw_required=1;
      }
      else if (comm=='M')
      { for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { mx[i]=comm_d[i];
          Serial.print("mx[");
          Serial.print(axis_name[i]);
          Serial.print("]=");
          Serial.println(mx[i]);
        }
        comm_n=0;
      }
      else if (comm=='V')
      { for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { V_max[i]=comm_d[i];
          Serial.print("V[");   Serial.print(axis_name[i]);
          Serial.print("]=");   Serial.println(V_max[i]);
        }
        if (txx<V_max[0])txx=V_max[0];
        if (tyy<V_max[1])tyy=V_max[1];
        if (tzz<V_max[2])tzz=V_max[2];
        if (tee<V_max[3])tee=V_max[3];
        if (tqq<V_max[4])tqq=V_max[4];
        
        comm_n=0;
      }
      else if (comm=='v')
      { for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { v_max[i]=comm_d[i];
          Serial.print("v[");    Serial.print(axis_name[i]);
          Serial.print("]=");    Serial.println(v_max[i]);
        }
        txx=v_max[0];tyy=v_max[1];tzz=v_max[2];tee=v_max[3];tqq=v_max[4];
        comm_n=0;
      }
      else if (comm=='T')
      { 
        if(comm_d[0]!=-1999999999)
        { termo[0]=comm_d[0];
          Serial.print("T[0]="); Serial.println(termo[0]);
        }
        if(comm_d[1]!=-1999999999)
        { termo[1]=comm_d[1];
          Serial.print("T[1]="); Serial.println(termo[1]);
        }
        if(comm_d[2]!=-1999999999)
        { termo[2]=comm_d[2];
          Serial.print("T[2]="); Serial.println(termo[2]);
        }
        pos_set[5]=termo[0];
        pos[5]=1000L*termo[2]+termo[1];
        SetT_T1();
        comm_n=0;
      }
      else if (comm=='D')
      { for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { ton_set[i]=comm_d[i];
          if( ((go[i]==2)&&(ton[i]==-1))||
              ((go[i]!=1)&&(ton[i]>=0)) ){ton[i]=ton_set[i];go[i]=2;}
          Serial.print("delay[");
          Serial.print(axis_name[i]);
          Serial.print("]=");
          Serial.println(ton_set[i]);
        }
        comm_n=0;
      }
      else
      { Serial.println("BadCommand");
        //comm_n=0;
      }
}//ExecCommand1
//=============================
void printDirectory(File dir, int numTabs) {
  dir.rewindDirectory();
  while (true) {

    File entry =  dir.openNextFile();
    if (! entry) {
      // no more files
      break;
    }
    for (uint8_t i = 0; i < numTabs; i++) {
      Serial.print('\t');
    }
    Serial.print(entry.name());
    if (entry.isDirectory()) 
    {
      Serial.println("/");
      printDirectory(entry, numTabs + 1);
    } else 
    {
      // files have sizes, directories do not
      Serial.print("\t\t");
      Serial.println(entry.size(), DEC);
    }
    entry.close();
  }
}

//=============================
void ExecCommand(void)
{ 
    Serial.print("Command=");Serial.print(comm);
    for(uint8_t i=0;i<5;i++)
    if(comm_d[i]!=-1999999999)
    { Serial.print(" ");
      Serial.print(axis_name[i]);
      Serial.print("=");
      Serial.print(comm_d[i]);
    }
    Serial.println();

    if(prog_write!=0)
    {
      if(comm=='E')
      {
        Serial.print("Prog[");  Serial.print(prog_n);
        Serial.println("]EndWrite");
        if(prog_write==1) EEPROM.write(prog_n*256+prog_ptr++,'_');
        else              {myFile.print('_');myFile.close();} 
        prog_write=0;
        comm_n=0;
      }
      else if((comm=='G')||(comm=='g')||(comm=='M')||(comm=='D')||(comm=='r')||
              (comm=='V')||(comm=='v')||(comm=='T')||(comm=='R'))

      { comm_m=255;
        for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)comm_m=i;

        if(comm_m!=255)
        {   
          Serial.print(comm);
          
          if(prog_write==1) EEPROM.write(prog_n*256+prog_ptr++,comm);
          else              myFile.print(comm); 
          for(uint8_t i=0;i<=comm_m;i++)
          {
            if((comm_d[i]!=-1999999999)&&((comm_d[i]!=0)||((comm!='G')&&(comm!='g'))))
            { Serial.print(comm_d[i]);
              if(comm_d[i]<0) 
              { 
                if(prog_write==1) EEPROM.write(prog_n*256+prog_ptr++,'-');
                else              myFile.print('-'); 
                comm_d[i]=-comm_d[i];
              }
              temp=comm_d[i];
              tmp=1;
              while(temp>=10)
              { temp/=10;
                tmp*=10;
              }  
              temp=comm_d[i];
              while(tmp>0)
              { c=temp/tmp;
                temp=temp-tmp*c;
                tmp/=10;
                c=c+'0';
                if(prog_write==1) EEPROM.write(prog_n*256+prog_ptr++,c);
                else              myFile.print(c); 
              }
            }
            if(i<comm_m)
            { Serial.print(';');
                if(prog_write==1) EEPROM.write(prog_n*256+prog_ptr++,';');
                else              myFile.print(';'); 
            }
          }
          Serial.println();
        }
        else
        { Serial.println("IgnoreWrite(NoData)");
        }
        comm_n=0;
      } 
      else
      { //WriteProg
        Serial.println("IgnoreWrite(BadCommand)");
        comm_n=0;
      }  
    }    //if(prog_write!=0)
    else //if(prog_write==0)
    {  
      if(comm=='A')//dir
      {
        Serial.println("dir SD Card:") ;
        root = SD.open("/");printDirectory(root, 0);Serial.println("done!");//===========
        comm_n=0;
      }
      else if(comm=='B')//createfile
      {if(comm_d[0]!=-1999999999)
       {//f_n[]="000000.GC";
        f_n[5]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[4]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[3]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[2]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[1]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[0]='0'+comm_d[0]%10;comm_d[0]/=10;
        
        Serial.print("Create prog[");Serial.print(f_n);
        Serial.println("]");
        SD.remove(f_n);
        myFile=SD.open(f_n, FILE_WRITE);
        myFile.close(); 
       } 
       comm_n=0;
      }
      else if(comm=='C')//DelFile
      {if(comm_d[0]!=-1999999999)
       {//f_n[]="000000.GC";
        f_n[5]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[4]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[3]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[2]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[1]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[0]='0'+comm_d[0]%10;comm_d[0]/=10;
        Serial.print("Delete prog[");Serial.print(f_n);
        Serial.print("]");
        if(SD.remove(f_n))Serial.println(" Ok");else Serial.println(" Error");
       } 
       comm_n=0;
      }
      else if (comm=='P')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=15))
        {
          prog_n=comm_d[0];
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]Write");
          prog_write=1;//eeprom
          prog_ptr=0;
        }
        comm_n=0;
      }
      else if (comm=='p')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=999999))
       {//f_n[]="000000.GC";
        f_n[5]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[4]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[3]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[2]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[1]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[0]='0'+comm_d[0]%10;comm_d[0]/=10;
        Serial.print("prog[");Serial.print(f_n);
        Serial.println("]WriteToFile");
        prog_write=2;//SD
        //prog_ptr=0;
        SD.remove(f_n);
        myFile=SD.open(f_n, FILE_WRITE);
        //myFile.close(); 
       } 
        comm_n=0;
      }
      else if (comm=='L')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=15))
        {
          prog_n=comm_d[0];
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]List");
          prog_ptr=0;
          while( (prog_ptr<255)&&((c=EEPROM.read(prog_n*256+prog_ptr++))!='_') )
          { 
            //comm==c;
            
            Serial.print(c);
          }
          Serial.println();
          Serial.println("EndProg");
        }
        comm_n=0;
      }
      else if (comm=='l')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=999999))
       {//f_n[]="000000.GC";
        f_n[5]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[4]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[3]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[2]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[1]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[0]='0'+comm_d[0]%10;comm_d[0]/=10;
        Serial.print("prog[");Serial.print(prog_n);
        Serial.print("]List");Serial.println(f_n);
        myFile=SD.open(f_n);
        if(myFile)
        {
          while(myFile.available())
          { c=myFile.read();
            Serial.print(c);
          }
          myFile.close(); 
          Serial.println("<end file>");
        }
        else Serial.println("Error");
       } 
       comm_n=0;
      } 
      else if (comm=='R')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=15))
        { 
          if(prog_run==1)
          {
            stack_n[stack]  =prog_n;
            stack_ptr[stack]=prog_ptr;
            stack_run[stack]=prog_run;
            stack++;
            Serial.print("stack=");
            Serial.println(stack);
          }
          if(prog_run==2)
          {
            prog_ptr=myFile.position();
            stack_n[stack]  =prog_n;
            stack_ptr[stack]=prog_ptr;
            stack_run[stack]=prog_run;
            stack++;
            Serial.print("stack=");
            Serial.println(stack);
          }
          prog_n=comm_d[0];
          prog_ptr=0;
          prog_run=1;
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]Run");
          comm_n=0;
         }
         else
         {
          Serial.println("progNoRun");
          comm_n=0;
         }
      } //comm=='R'
      else if (comm=='r')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=999999))
       { 
        comm_d[1]=comm_d[0];
        //f_n[10]="000000.GC";
        f_n[5]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[4]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[3]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[2]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[1]='0'+comm_d[0]%10;comm_d[0]/=10;
        f_n[0]='0'+comm_d[0]%10;comm_d[0]/=10;
        //Serial.print("prog[");Serial.print(f_n);
        //Serial.println("]Run");          

          if(prog_run==1)
          {
            stack_n[stack]  =prog_n;
            stack_ptr[stack]=prog_ptr;
            stack_run[stack]=prog_run;
            stack++;
            Serial.print("prog_n=");     Serial.println(prog_n);
            Serial.print("prog_ptr=");   Serial.println(prog_ptr);
            Serial.print("prog_run=");   Serial.println(prog_run);
            
            Serial.print("stack=");      Serial.println(stack);
          }
          if(prog_run==2)
          {
            prog_ptr=myFile.position();
            stack_n[stack]  =prog_n;
            stack_ptr[stack]=prog_ptr;
            stack_run[stack]=prog_run;
            
            stack++;
            Serial.print("prog_n=");     Serial.println(prog_n);
            Serial.print("prog_ptr=");   Serial.println(prog_ptr);
            Serial.print("prog_run=");   Serial.println(prog_run);

            Serial.print("stack=");      Serial.println(stack);
          }
          
          myFile=SD.open(f_n);
          if(myFile)
          {
          prog_n=comm_d[1];
          prog_ptr=0;
          prog_run=2;
          Serial.print("prog[");
          Serial.print(f_n);
          Serial.println("]Run");
          }
          else Serial.println("Error");
          
       }
       else
       {
         Serial.println("progNoRun");
       }
        comm_n=0;
      } //comm=='R'
      
      else if((comm=='G')||(comm=='g')||(comm=='M')||(comm=='D')||
              (comm=='V')||(comm=='v')||(comm=='T'))
      { //prog_run=0;
        ExecCommand1();
        //comm_n=0;
      }
      else
      { Serial.println("BadCommand");
        comm_n=0;
      }
    }//if(prog_write==0)  
}//ExecCommand 

