//---------------------------------------------------------------------------
#include <vcl.h>
#include <math>
#include "IniFiles.hpp"
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"

  //read COM
  char comm;
  char comm_char;
  int  comm_zn;
  int  comm_dig;
  int  comm_n;
  int  comm_m;
  int  comm_d[7];
const  char axis_name[7]={'X','Y','Z','C','E','T','R'};

static int p;

char CR = 13;
char LF = 10;
char EQ = '=';
char NUL ='0';
char ONE ='1';

char CRLF[2]={13,10};

TImage * Btm;

int x1,y1,minx=-200,miny=-200,maxx=200,maxy=200;
int       minxe,minye,maxxe,maxye;
int mm[15]={1,2,5,10,20,50,100,200,500,1000,2000,5000,10000,20000,50000};
int m=5;
int m_old=3;

String File;
int flag1=0;

int dx[1000]={0,0,0};
int dy[1000]={1,0,-1};
int dz[1000]={0,-1,0};
int d=0;

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CCALENDR"
#pragma link "CSPIN"
#pragma resource "*.dfm"


TForm2 *Form2;

//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
  OpenDialog1->Filter="G cod(*.gcod)|*.gcod";
  if (OpenDialog1->Execute())
  {
     File=OpenDialog1->FileName;
     
     maxx=0;
     maxy=0;
     minx=0;
     miny=0;
     x1=0;
     y1=0;
     flag1=0;
     Timer1->Enabled=false;
     Timer1->Enabled=true;

  }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::PDraw(int xv, int yv)
{
  x1-=xv;
  y1-=yv;
  if(minx>x1)minx=x1;
  if(miny>y1)miny=y1;
  if(maxx<x1)maxx=x1;
  if(maxy<y1)maxy=y1;
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Draw(int xv, int yv)
{
  x1-=xv;
  y1-=yv;
  Btm->Canvas->LineTo(x1,y1);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button2Click(TObject *Sender)
{ Memo1->Clear();
  RichEdit1->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button4Click(TObject *Sender)
{
   Form1->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Edit2KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{       if (Key==13)
        { Key=0;
          if(Shift==TShiftState()<<ssShift)
               DrawCmd0(Edit2->Text);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Edit2KeyPress(TObject *Sender, char &Key)
{       if (Key==13) Key=0;
        if (Key==27){Key=0;Edit2->Text="";
        //p=0;
        }}
//---------------------------------------------------------------------------
void __fastcall TForm2::DrawCmd0(AnsiString ttxt)
{  char cc=10;
   RichEdit1->SelAttributes->Color = clPurple;
   RichEdit1->Lines->Add(ttxt);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::DrawCmd1(AnsiString ttxt)
{ char cc=10;
   RichEdit1->SelAttributes->Color = clPurple;
   RichEdit1->Lines->Add(ttxt);
   Edit2->Text=Edit2->Text+ttxt;
   Edit3->Text=ttxt;
}
//---------------------------------------------------------------------------



void __fastcall TForm2::Edit3KeyPress(TObject *Sender, char &Key)
{       if (Key==13) Key=0;
        if (Key==27){Key=0;Edit3->Text="";}}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button5Click(TObject *Sender)
{        d=0;p=0;
//       Redraw();
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Redraw(void)
{
      if(Btm!=NULL)
      {
      try{
        //if(m_old!=m)
        {
          delete Btm;
        }
      }
      catch(Exception *ex){  }
      }
      {
        //if(m_old!=m)
       {
        m_old=m;
        Btm = new TImage(ScrollBox1);
        Btm->Left=0;
        Btm->Top=0;
        Btm->Width =abs(minx)+abs(maxx)+2*m;
        Btm->Height=abs(miny)+abs(maxy)+2*m;
        Btm->Parent=ScrollBox1;
        Btm->Visible=true;
        Btm->Canvas->Pen->Color  =clBlue;
        Btm->Canvas->Brush->Color=clBlue;
        x1=abs(minx)+m;
        y1=abs(miny)+m;
        Btm->Canvas->Ellipse(x1-4,y1-4,x1+4,y1+4);
        Btm->Canvas->MoveTo(x1,y1);
        Btm->Canvas->Pen->Color=0;
        Btm->Canvas->Pen->Width=1;
        x1=abs(minx)+m;
        y1=abs(miny)+m;
        flag1=1;

        for(int i=0;i<d;i++)
        { x1+=dy[i]*m;
          y1-=dz[i]*m;
          Btm->Canvas->LineTo(x1,y1);
        }
        Btm->Canvas->Pen->Color  =clRed;
        Btm->Canvas->Brush->Color=clRed;
        Btm->Canvas->Ellipse(x1-3,y1-3,x1+3,y1+3);
       }
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm2::TrackBar1Change(TObject *Sender)
{    Edit1->Text=m=mm[TrackBar1->Position];  Redraw();}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormClose(TObject *Sender, TCloseAction &Action)
{    Form1->SpeedButton15->Down=false;}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{    Redraw();}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button8Click(TObject *Sender)
{    d=0; Redraw();}
//---------------------------------------------------------------------------
char __fastcall TForm2::SerialAvailable(void)
{  int n;
   AnsiString txt;
   txt=Edit2->Text//+"/n"
   ;
   n=txt.Length();
   if(n-p>=0)
   return(n-p);
   else return(0);
}
//---------------------------------------------------------------------------
char __fastcall TForm2::SerialPeek(void)
{  int n;
   AnsiString txt;
   txt=Edit2->Text//+"/n"
   ;
   n=txt.Length();
   if(p<n) return(txt[p+1]);
   else return(-1);
}
//---------------------------------------------------------------------------
char __fastcall TForm2::SerialRead(void)
{  int n;
   AnsiString txt;
   txt=Edit2->Text//+"/n"
   ;
   n=txt.Length();
   if(p<n)
   { p++;
     return(txt[p]);
   }
   else return(-1);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Edit4KeyPress(TObject *Sender, char &Key)
{       if (Key==13) Key=0;
        if (Key==27){Key=0;Edit4->Text="";}}
//---------------------------------------------------------------------------
//===========================
char __fastcall TForm2::peek(void)
{ //if(prog_run==0)
  return(SerialPeek() );
  /*
  else
  { c=EEPROM.read(prog_n*256+prog_ptr);
    return(c);
  }
  */
}
//===========================
char __fastcall TForm2::read(void)
{ //if(prog_run==0)
  return(SerialRead() );
/*
  else
  { c=EEPROM.read(prog_n*256+prog_ptr++);
   if(c=='_')
    {
      //Serial.print("Prog[");           Serial.print(prog_n);
      //Serial.println("]EndRun");
      if(stack>0)
      {
            stack--;
            prog_n=stack_n[stack];
            prog_ptr=stack_ptr[stack];
            //Serial.print("stack=");   Serial.println(stack);
      }
      else prog_run=0;
    }
    return(c);
  }
*/
}
//===========================
char __fastcall TForm2::available(void)
{ //if(prog_run==0)
  return(SerialAvailable() );
/*
  else
  {
    if( (prog_ptr>0)&&(EEPROM.read(prog_n*256+prog_ptr-1)=='_') )
    return(0);
    else
    return(1);
  }
*/
}
//===========================
char __fastcall TForm2::read_command(void)
{
  if (available()>0)
  { if(comm_n==0)
    { comm_char=read();
      if((comm_char>='A')&&(comm_char<='z'))
      { comm=comm_char;
        comm_n=1;comm_zn=1;comm_dig=0;
        comm_d[0]=-1999999999;comm_d[1]=-1999999999;comm_d[2]=-1999999999;
        comm_d[3]=-1999999999;comm_d[4]=-1999999999;comm_d[5]=-1999999999;
        comm_d[6]=-1999999999;
      }
    }
    else if((comm_n>0)&&(comm_n<7))
    {
      comm_char=peek();
      if((comm_char==10)||(comm_char=='_')||((comm_char>='A')&&(comm_char<='z')))
      { comm_n=7;}
      else if(comm_char=='-'){comm_char=read();comm_zn=-1;}
      else if((comm_char>='0')&&(comm_char<='9'))
      { comm_char=read();
        comm_dig=comm_dig*10+(comm_char-'0');
        if(comm_n<7){comm_d[comm_n-1]=comm_zn*comm_dig;}
      }
      else comm_char=read();
      if(comm_char==';'){comm_n++;comm_zn=1;comm_dig=0;}
    }
    else if(comm_n==7)
    { comm_n=8;
      if(comm!='_') ExecCommand();
      else
      comm_n=0;
    }
  }
}
//=============================
void __fastcall TForm2::ExecCommand(void)
{
   AnsiString ttt;

   RichEdit1->SelAttributes->Color = clRed;
   ttt="Command=";
   ttt=ttt+comm;
   RichEdit1->Lines->Add(ttt);

//   RichEdit1->SelAttributes->Color = clRed;
//   RichEdit1->Lines->Add(IntToStr(comm_n)+comm+IntToStr(comm_d[0]) );

   ttt="";
   for(int i=0;i<6;i++)
   if(comm_d[i]!=-1999999999)
   { ttt=ttt+axis_name[i]+"="+IntToStr(comm_d[i])+" ";
   }
   RichEdit1->SelAttributes->Color = clRed;
   RichEdit1->Lines->Add(ttt);

   comm_n=0;//======

  /*

    if(prog_write!=0)
    {
      if(comm=='E')
      {
        Serial.print("Prog[");  Serial.print(prog_n);
        Serial.println("]EndWrite");
        EEPROM.write(prog_n*256+prog_ptr++,'_');
        prog_write=0;
        comm_n=0;
      }
      else if((comm=='G')||(comm=='g')||(comm=='M')||(comm=='D')||
              (comm=='V')||(comm=='v')||(comm=='T')||(comm=='R'))

      { comm_m=255;
        for(uint8_t i=0;i<6;i++)
        if(comm_d[i]!=-1999999999)comm_m=i;

        if(comm_m!=255)
        {   
          Serial.print(comm);
          EEPROM.write(prog_n*256+prog_ptr++,comm);
          for(uint8_t i=0;i<=comm_m;i++)
          {
            if((comm_d[i]!=-1999999999)&&(comm_d[i]!=0))
            { Serial.print(comm_d[i]);
              if(comm_d[i]<0) 
              { EEPROM.write(prog_n*256+prog_ptr++,'-');
                comm_d[i]=-comm_d[i];
              }
              temp=comm_d[i];
              tmp=1;
              while(temp>=10)
              { temp/=10;
                tmp*=10;
              }  
              temp=comm_d[i];
              while(tmp>0)
              { c=temp/tmp;
                temp=temp-tmp*c;
                tmp/=10;
                c=c+'0';
                EEPROM.write(prog_n*256+prog_ptr++,c);
              }
            }
            if(i<comm_m)
            { Serial.print(';');
              EEPROM.write(prog_n*256+prog_ptr++,';');
            }
          }
          Serial.println();
        }
        else
        { Serial.println("GIgnoreWrite");
        }
        comm_n=0;
      } 
      else
      { //WriteProg
        Serial.println("BadCommand");
        comm_n=0;
      }  
    }    //if(prog_write!=0)
    else //if(prog_write==0)
    {  
      if (comm=='P')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=7))
        {
          prog_n=comm_d[0];
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]Write");
          prog_write=1;
          prog_ptr=0;
        }
        comm_n=0;
      }
      else if (comm=='L')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=7))
        {
          prog_n=comm_d[0];
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]List");
          prog_ptr=0;
          while( (prog_ptr<255)&&((c=EEPROM.read(prog_n*256+prog_ptr++))!='_') )
          { 
            //comm==c;
            
            Serial.print(c);
          }
          Serial.println();
          Serial.println("EndProg");
        }
        comm_n=0;
      }
      else if (comm=='R')
      { if( (comm_d[0]>=0)&&(comm_d[0]<=7))
        { 
          if(prog_run==1)
          {
            stack_n[stack]  =prog_n;
            stack_ptr[stack]=prog_ptr;
            stack++;
            Serial.print("stack=");
            Serial.println(stack);
          }
          prog_n=comm_d[0];
          prog_ptr=0;
          prog_run=1;
          Serial.print("prog[");
          Serial.print(prog_n);
          Serial.println("]Run");
          comm_n=0;
         }
         else
         {
          Serial.println("progNoRun");
          comm_n=0;
         }
//         Serial.println("EndProg");
//         prog_run=0;
//         comm_n=0;
      } //comm=='R'
      else
*/
           if((comm=='G')
//                         ||(comm=='g')||(comm=='M')||(comm=='D')||
//              (comm=='V')||(comm=='v')||(comm=='T')
             )
           ExecCommand1();
      else
      {
        RichEdit1->SelAttributes->Color = clRed;
        RichEdit1->Lines->Add("BadCommand");
        //Serial.println("BadCommand");
        comm_n=0;
      }
/*
    }//if(prog_write==0)
 */
}//ExecCommand
//---------------------------------------------------------------------------
void __fastcall TForm2::Button9Click(TObject *Sender)
{
        read_command();
        Edit4->Text=IntToStr(comm_n)+comm+IntToStr(comm_d[0])+" "+IntToStr(comm_d[1]);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Timer1Timer(TObject *Sender)
{
        read_command();
        Edit4->Text=IntToStr(comm_n)+comm+IntToStr(comm_d[0])+" "+IntToStr(comm_d[1]);
}
//---------------------------------------------------------------------------
void __fastcall TForm2::CheckBox1Click(TObject *Sender)
{
        Timer1->Enabled=CheckBox1->Checked;
}
//---------------------------------------------------------------------------
//=============================
void __fastcall TForm2::ExecCommand1(void)
{
        dx[d]=0;
        dy[d]=0;
        dz[d]=0;

        if(comm_d[1]!=-1999999999)
        { dy[d]=comm_d[1];}
        if(comm_d[2]!=-1999999999)
        { dz[d]=comm_d[2];}
        d++;
        Redraw();
        RichEdit1->Lines->Add("Go!");
        comm_n=0;

/*
      if((comm=='G')||(comm=='g'))
      { if (comm=='G')
        { txx=V_max[0];tyy=V_max[1];tzz=V_max[2];
          tee=V_max[3];tqq=V_max[4];}
        else
        { txx=v_max[0];tyy=v_max[1];tzz=v_max[2];
          tee=v_max[3];tqq=v_max[4];}

        for(uint8_t i=0;i<6;i++)
        if(comm_d[i]!=-1999999999)
        { pos_set[i]+=comm_d[i]*mx[i];
          Serial.print("pos_set[");  Serial.print(axis_name[i]);
          Serial.print("]=");        Serial.println(pos_set[i]);
        }
        Go();
        menu_redraw_required=1;
      }
      else if (comm=='M')
      { for(uint8_t i=0;i<6;i++)
        if(comm_d[i]!=-1999999999)
        { mx[i]=comm_d[i];
          Serial.print("mx[");
          Serial.print(axis_name[i]);
          Serial.print("]=");
          Serial.println(mx[i]);
        }
        comm_n=0;
      }
      else if (comm=='V')
      { for(uint8_t i=0;i<6;i++)
        if(comm_d[i]!=-1999999999)
        { V_max[i]=comm_d[i];
          Serial.print("V[");   Serial.print(axis_name[i]);
          Serial.print("]=");   Serial.println(V_max[i]);
        }
        if (txx<V_max[0])txx=V_max[0];
        if (tyy<V_max[1])tyy=V_max[1];
        if (tzz<V_max[2])tzz=V_max[2];
        if (tee<V_max[3])tee=V_max[3];
        if (tqq<V_max[4])tqq=V_max[4];
        
        comm_n=0;
      }
      else if (comm=='v')
      { for(uint8_t i=0;i<6;i++)
        if(comm_d[i]!=-1999999999)
        { v_max[i]=comm_d[i];
          Serial.print("v[");    Serial.print(axis_name[i]);
          Serial.print("]=");    Serial.println(v_max[i]);
        }
        txx=v_max[0];tyy=v_max[1];tzz=v_max[2];tee=v_max[3];tqq=v_max[4];
        comm_n=0;
      }
      else if (comm=='T')
      { 
        if(comm_d[0]!=-1999999999)
        { pos_set[5]=comm_d[0];
          pos[5]=comm_d[0];
          menu_redraw_required=1;
        }
        if(comm_d[1]!=-1999999999)
        { pos_set[6]=comm_d[1];
          pos[6]=comm_d[1];
          menu_redraw_required=1;
        }
        comm_n=0;
      }
      else if (comm=='D')
      { for(uint8_t i=0;i<5;i++)
        if(comm_d[i]!=-1999999999)
        { ton_set[i]=comm_d[i];
          if( ((go[i]==2)&&(ton[i]==-1))||
              ((go[i]!=1)&&(ton[i]>=0)) ){ton[i]=ton_set[i];go[i]=2;}
          Serial.print("delay[");
          Serial.print(axis_name[i]);
          Serial.print("]=");
          Serial.println(ton_set[i]);
        }
        comm_n=0;
      }
      else
      { Serial.println("BadCommand");
        //comm_n=0;
      }
*/
}//ExecCommand1
//=============================
void __fastcall TForm2::Edit3KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{       if (Key==13)
        { Key=0;
          if(Shift==TShiftState()<<ssShift)
          {    DrawCmd1(Edit3->Text);
               p=0;
          }
        }
}
//---------------------------------------------------------------------------


