#include "wiring_private.h"
#include <SPI.h>
#include <SD.h>
File root;
File myFile;
char f_n[]="000000.GC";
//String FileName;
//hardware\arduino\avr\cores\arduino\wiring_analog.c 
  #include <EEPROM.h>
  #include <U8glib.h>
  #include <TimerOne.h>

  #define X_STEP_PIN          A0
  #define X_DIR_PIN           A1
  #define X_ENABLE_PIN        38
  #define X_MIN_PIN           3
  #define X_MAX_PIN           2
  
  #define Y_STEP_PIN          A6
  #define Y_DIR_PIN           A7
  #define Y_ENABLE_PIN        A2  
  #define Y_MIN_PIN           14
  #define Y_MAX_PIN           15      
  
  #define Z_STEP_PIN          46
  #define Z_DIR_PIN           48
  #define Z_ENABLE_PIN        A8
  #define Z_MIN_PIN           18
  #define Z_MAX_PIN           19  
 
  #define E_STEP_PIN         26
  #define E_DIR_PIN          28
  #define E_ENABLE_PIN       24

  #define Q_STEP_PIN         36
  #define Q_DIR_PIN          34
  #define Q_ENABLE_PIN       30
        
  #define LED                 13 

  #define END_A               31
  #define END_B               33
  #define END_S               35
  #define KEY_S               41 

uint32_t tim01;//micros
uint32_t tim02;//tact timer1

uint16_t tim0,tim1,tim2,tim3,tim4,tim5,tim6;//===============

//eeprom
int8_t  prog_write;
int8_t  prog_run;
int8_t  prog_n,prog_n_w;
int16_t prog_ptr,prog_ptr_w; 
int8_t  stack_n[10];
int16_t stack_ptr[10];
int8_t  stack_run[10];
int8_t  stack,stack_w;

//read COM
char    comm_char;
int8_t  comm_zn;
long    comm_dig;

uint8_t commA_h;
char    comm;
uint8_t comm_n;
long    comm_d[5];
uint8_t comm_m;

long mx[6]={10,10,256,1,1,1};

int8_t enc,enc_inc;
uint8_t enc_A_old, enc_A_new;
uint8_t enc_B_new;

uint8_t enc_s,enc_s_old,enc_s_inc;
uint8_t key_s,key_s_old,key_s_inc;
uint8_t enc_S_old, enc_S_new;
uint8_t key_S_old, key_S_new;

char xmin,ymin,zmin;
char xmax,ymax,zmax;
char xminold=10,yminold=10,zminold=10;
char xmaxold=10,ymaxold=10,zmaxold=10;
         
uint8_t qq;

uint8_t select,axis,mul;
const    long mul_tab[6]={1,10,100,1000,10000,100000};

//enable & off motor
         
         int ton[5];
         int ton_set[6] ={5000,5000,5000,5000,5000};  
         uint8_t t_q; 
         
         uint16_t tx,ty,tz,te,tq;                   //for speed
         uint16_t txx=50,tyy=50,tzz=2,tee=2,tqq=2; //speed
         uint8_t  maxxyz,mov,q;

         long   temp,tmp,i;
         int8_t dx,       dy,        dz,        de,     dq;
         long   deltax,   deltay,    deltaz,    deltae, deltaq;
         long   error,    error2,    error3,    error4;
         long   deltaerr, deltaerr2, deltaerr3, deltaerr4;

         long    min_x=-10, min_x_prog, max_x_prog, max_x;
         long    min_y=-10, min_y_prog, max_y_prog, max_y;
         long    min_z=-10, min_z_prog, max_z_prog, max_z;
         uint8_t prog_minmax; 

         uint16_t v_max[6]={50, 50, 2,  2,  50};
         uint16_t V_max[6]={50, 50, 2,  5,  50};
         
         uint8_t termo[3];
         uint8_t go[6]     ={0,0,0,0,0,0};
         uint8_t go_disp[6]={9,9,9,9,9,9};
         long pos_set[6]     ={ 0, 0, 0, 0, 0, 0};
volatile long pos[6]         ={ 0, 0, 0, 0, 0, 0}; 
         long pos_set_disp[6]={-999999,-999999,-999999,-999999,-999999,-999999};
         long pos_disp[6]    ={-999999,-999999,-999999,-999999,-999999,-999999};
const    char axis_name[7]   ={'X','Y','Z','C','E','T','R'};

uint16_t k1;
volatile char flag;

char c;
//char *text = "X = 000000";
uint8_t ProgN=0;

U8GLIB_ST7920_128X64_4X u8g(23, 17, 16);  
// SPI Com: SCK = en = 18, MOSI = rw = 16, CS = di = 17

void Go(void)
{
                  //================
                  //tim2=tim0;
                  //Serial.print("Go=");
                  //Serial.println(tim2-tim1);
                  //tim1=tim2;
  
        deltax=pos_set[0]-pos[0];
        deltay=pos_set[1]-pos[1];
        deltaz=pos_set[2]-pos[2];
        deltae=pos_set[3]-pos[3];
        deltaq=pos_set[4]-pos[4];
        if(deltax!=0)go[0]=1;
        if(deltay!=0)go[1]=1;
        if(deltaz!=0)go[2]=1;
        if(deltae!=0)go[3]=1;
        if(deltaq!=0)go[4]=1;

        if(deltax>0)dx=1; else if(deltax<0){dx=-1;deltax=-deltax;} else dx=0;
        if(deltay>0)dy=1; else if(deltay<0){dy=-1;deltay=-deltay;} else dy=0;
        if(deltaz>0)dz=1; else if(deltaz<0){dz=-1;deltaz=-deltaz;} else dz=0;
        if(deltae>0)de=1; else if(deltae<0){de=-1;deltae=-deltae;} else de=0;
        if(deltaq>0)dq=1; else if(deltaq<0){dq=-1;deltaq=-deltaq;} else dq=0;

        maxxyz=0; temp=deltax;
        if(deltay>temp){temp=deltay; maxxyz=1;}
        if(deltaz>temp){temp=deltaz; maxxyz=2;}
        if(deltae>temp){temp=deltae; maxxyz=3;}
        if(deltaq>temp){temp=deltaq; maxxyz=4;}

        if(maxxyz==1) {temp=deltay;deltay=deltax;deltax=temp;}
        if(maxxyz==2) {temp=deltaz;deltaz=deltax;deltax=temp;}
        if(maxxyz==3) {temp=deltae;deltae=deltax;deltax=temp;}
        if(maxxyz==4) {temp=deltaq;deltaq=deltax;deltax=temp;}

        error=0;         error2=0;         error3=0;         error4=0;
        deltaerr=deltay; deltaerr2=deltaz; deltaerr3=deltae; deltaerr4=deltaq;
        i=0; q=0;tx=0;ty=0;tz=0;te=0;tq=0;
        mov=1;
                  //===================
                  //tim2=tim0;
                  //Serial.print("Mov=");
                  //Serial.println(tim2-tim1);
                  //tim1=tim2;
}

void encoderSetup(void) 
{ // configure input keys,encoder 
  pinMode(END_A, INPUT_PULLUP);
  pinMode(END_B, INPUT_PULLUP);
  pinMode(END_S, INPUT_PULLUP);
  pinMode(KEY_S, INPUT_PULLUP); 
}

void encoderStep(void) 
{
  enc_A_old=enc_A_new;
  enc_A_new=digitalRead(END_A);
  enc_B_new=digitalRead(END_B);
  if( (enc_A_old==1)&&(enc_A_new==0))
  {
    if(enc_B_new==1) 
    { enc++;
      enc_inc=1;
    }
    else
    { enc--;
      enc_inc=-1;
    }
  }
  enc_s_old=enc_s;
  enc_S_old=enc_S_new;
  enc_S_new=digitalRead(END_S);
  if( (enc_S_old==0)&&(enc_S_new==0))
  { enc_s=1;
    if(enc_s_old==0)enc_s_inc=1;
  }
  else enc_s=0;

  key_s_old=key_s;
  key_S_old=key_S_new;
  key_S_new=digitalRead(KEY_S);
  if( (key_S_old==0)&&(key_S_new==0))
  { key_s=1;
    if(key_s_old==0)key_s_inc=1;;
  }
  else key_s=0;
} 

#define MENU_ITEMS 6
/*
char *menu_strings[MENU_ITEMS] = 
{ 
  "Max",
  "Inc",
  "Go!",
  "Dec", 
  "Min", 
  "Prg0"
};
*/
const  uint8_t h=9;

uint8_t com = 1;
uint8_t menu_redraw_required = 0;//==============
/*
void drawMenu(void) 
{ uint8_t i,j;
  u8g_uint_t w, d;
  long pos_Copy;

  u8g.setFont(u8g_font_6x12);
  u8g.setFontRefHeightText();
//  u8g.setFontPosTop();
  u8g.setFontPosBottom();
//  h = u8g.getFontAscent()-u8g.getFontDescent();
//  w = u8g.getWidth();

    u8g.setDefaultForegroundColor();
    u8g.drawFrame(0, 0, 128, 10);
    u8g.drawStr  (2, 10, "Com Axis Set  Current ");


//    if( (go[0]==0)||(go[0]==6) ) menu_strings[2]="Go!";
//    else      menu_strings[2]="Stop";
    
    for( i = 0; i < MENU_ITEMS; i++ ) 
    { u8g.setDefaultForegroundColor();
      if((i==com)&&(select==0)) 
      { u8g.drawBox(0,1+h+i*h, 23, h);
        u8g.setDefaultBackgroundColor();
      }
      u8g.drawStr(0, 2+2*h+i*h,menu_strings[i]);
    }
  for( i = 0; i < 6; i++ ) 
  {
    text[0]=axis_name[i];
    text[1]='0'+go[i];
    text[2]=0;
    u8g.setDefaultForegroundColor();
    if((i==axis)
      //&&(select==1)
                 )  //=====
    { u8g.drawBox(31, 1+h+i*h, 11, h);
      u8g.setDefaultBackgroundColor();
    }
    u8g.drawStr(31, 2+2*h+i*h, text);

    for( j = 0; j < 2; j++ ) 
    {
      if(j==0) pos_Copy = pos_set[i];
      else     pos_Copy = pos[i];
      if(pos_Copy<0)
      { pos_Copy = -pos_Copy;
        text[3]='-';
      }
      else text[3]=' ';
      text[4]='0'+pos_Copy /100000  % 10;
      text[5]='0'+pos_Copy / 10000  % 10;
      text[6]='0'+pos_Copy /  1000  % 10;
      text[7]='0'+pos_Copy /   100  % 10;
      text[8]='0'+pos_Copy /    10  % 10;
      text[9]='0'+pos_Copy          % 10;
      u8g.setDefaultForegroundColor();
      if((i==axis)&&(select==2+j))  //=====
      { u8g.drawBox(43+j*43, 1+h+i*h, 41, h);
        u8g.setDefaultBackgroundColor();
      }
        u8g.drawStr(43+j*43, 2+2*h+i*h, text+3);
        if(select==2) u8g.setDefaultBackgroundColor();
        else          u8g.setDefaultForegroundColor();
        if((i==axis)&&((select==2)||(select==3)))  //=====
        u8g.drawHLine(79-6*mul, 2*h+i*h, 5);
    }
  }
}
*/

void updateMenu(void) 
{
  if ( (enc_inc==0)&&(enc_s_inc==0)&&(key_s_inc==0)&&(key_s==0))
  {
    return;
  }

  //stop_key
  if( (key_s_inc==1) && ((select==2)||(select==3)) )
  {  key_s_inc=0;
     mul++;
     if(mul==6)mul=0;
     menu_redraw_required = 1;
     return;
  }

  if( (key_s_inc==1) && (select==0) )
  {  key_s_inc=0;
     if((com==0)||(com==2)||(com==4))
     { 
       //if((go[axis]%6)==0) go[axis]=com+1;
       //else      go[axis]=6;
       //menu_redraw_required = 1;
       //return;
     }
     if((com==0)||(com==4))return;

     if((com==2))//Go!
     { 
      Go();
     }
     if(com==5)
     { 
//       if(StartPrg==0) StartProg();
//       else StartPrg=0;
       return;
     }
  }
  //'Inc/Dec'
  if( (key_s==1) && (select==0) )
  {  if((com==1)||(com==3))
     { //go[axis]=com+1;
//       menu_redraw_required = 1;
       return;
     }
  }
  //encoder_key
  if(enc_s_inc==1)
  {  enc_s_inc=0;
  if(com!=5)
    {
     select++;
     if(select==4)select=0;
     menu_redraw_required = 1;
     return;
    }
    else
    {
      ProgN++; 
      ProgN&=7;
//      menu_strings[5][3]='0'+ProgN;
      menu_redraw_required = 1;
    }
  }
  //encoder inc/dec
  if(select==0)//Menu
  {
    switch ( enc_inc ) 
    {
      case 1:
        com++;
        if ( com >= MENU_ITEMS )
          com = 0;
        menu_redraw_required=1;
      
        break;
      case -1:
        if ( com == 0 )
          com = MENU_ITEMS;
        com--;
        menu_redraw_required=1;
        break;
    }
    enc_inc=0;
  }
  if(select==1)//Axis
  {
    switch ( enc_inc ) 
    {
      case 1:
        axis++;
        if (axis>=6)axis = 0;
        break;
      case -1:
        if (axis==0)axis=6;
        axis--;
        break;
    }
    menu_redraw_required=1;
    enc_inc=0;
  }
  if((select==2)||(select==3))//Set
  {
    pos_set[axis]+=enc_inc*mul_tab[mul];
    if(select==3)Go();
    menu_redraw_required=1;
    enc_inc=0;
  }
}
void setup() 
{
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  analogWrite(8, 0);
  analogWrite(9, 0);
  analogWrite(10,0);
  
  Serial.begin(57600); 
  Serial.println("   /----------------------/");
  Serial.println("  /     CNC-2D/3D/4D     /");
  Serial.println(" /  Armyansk-2015..2016 /");
  Serial.println("/----------------------/");

  
  pinMode(X_STEP_PIN, OUTPUT);
  pinMode(X_DIR_PIN, OUTPUT);
  pinMode(X_ENABLE_PIN, OUTPUT);
  pinMode(X_MIN_PIN, INPUT_PULLUP);  
  pinMode(X_MAX_PIN, INPUT_PULLUP);  
  
  pinMode(Y_STEP_PIN, OUTPUT);
  pinMode(Y_DIR_PIN, OUTPUT);
  pinMode(Y_ENABLE_PIN, OUTPUT);
  pinMode(Y_MIN_PIN, INPUT_PULLUP);  
  pinMode(Y_MAX_PIN, INPUT_PULLUP);  
  
  pinMode(Z_STEP_PIN, OUTPUT);
  pinMode(Z_DIR_PIN, OUTPUT);
  pinMode(Z_ENABLE_PIN, OUTPUT);
  pinMode(Z_MIN_PIN, INPUT_PULLUP);  
  pinMode(Z_MAX_PIN, INPUT_PULLUP);  

  pinMode(E_STEP_PIN, OUTPUT);
  pinMode(E_DIR_PIN, OUTPUT);
  pinMode(E_ENABLE_PIN, OUTPUT);
  
  pinMode(Q_STEP_PIN, OUTPUT);
  pinMode(Q_DIR_PIN, OUTPUT);
  pinMode(Q_ENABLE_PIN, OUTPUT);
  
  pinMode(LED, OUTPUT);
  digitalWrite(X_ENABLE_PIN, HIGH);
  digitalWrite(X_DIR_PIN, LOW);
  
  digitalWrite(Y_ENABLE_PIN, HIGH);
  digitalWrite(Y_DIR_PIN, LOW);

  digitalWrite(Z_ENABLE_PIN, HIGH);
  digitalWrite(Z_DIR_PIN, LOW);

  digitalWrite(E_ENABLE_PIN, HIGH);
  digitalWrite(E_DIR_PIN, LOW);

  digitalWrite(Q_ENABLE_PIN, HIGH);
  digitalWrite(Q_DIR_PIN, LOW);


//  Timer1.initialize(300);
  Timer1.initialize(300);
  Timer1.attachInterrupt(Timer1Interrupt); // Timer1Interrupt to run every 200 microseconds
  pinMode(12, OUTPUT);//=========

  encoderSetup();                                
  setupLCD();
  ClearScreen1();
//  Serial.print("ClearScreen1()=");    //
//  Serial.println(tim0-tim2);//-------//

//  //==================================//
//  tim02=micros();                    //
//  Serial.print(">>ClearScreen1()=");//
//  Serial.print(tim02-tim01);       //
//  Serial.println(" us");          //
  //=============================//
  
//  tim01=micros();//===================//
//  delay(500);
  //==================================//
//  tim02=micros();                    //
//  Serial.print(">>delay(500)=");    //
//  Serial.print(tim02-tim01);       //
//  Serial.println(" us");          //
  //=============================//
  
//  tim01=micros();//===================//
    ClearScreen();
  //==================================//
//  tim02=micros();                    //
//  Serial.print(">>ClearScreen()="); //
//  Serial.print(tim02-tim01);       //
//  Serial.println(" us");          //
  //=============================//
    
//  tim01=micros();//===================//
//  for(int iii=0;iii<12;iii++)
//    disp_set_position();
//  pos_set[0]=20;
//  for(int iii=0;iii<12;iii++)
//    disp_set_position();
  //==================================//
//  tim02=micros();                    //
//  Serial.print(">>disp_set_position()="); //
//  Serial.print(tim02-tim01);       //
//  Serial.println(" us");          //
  //=============================//
  beep();  
//  tim01=micros();//===================//
  //==================================//
//  tim02=micros();                    //
//  Serial.print(">>disp_set_position()="); //
//  Serial.print(tim02-tim01);       //
//  Serial.println(" us");          //
  //=============================//
  beep();  
  
//disp_position();
disp_title();

  pinMode(53, OUTPUT);
  Serial.println("Initializing SD card...");
  if (!SD.begin(53)) Serial.println("initialization failed!");
  else               Serial.println("initialization done.");
 
}
//=================================
void Inc_x(void)
{ 
  //if (digitalRead(X_MAX_PIN)==0)
  if((PINE&0b00010000)==0)
  { 
    digitalWrite(X_ENABLE_PIN, LOW);
//PORTD&=0b01111111;
    digitalWrite(X_DIR_PIN, LOW);
//PORTF&=0b11111101;
    digitalWrite(X_STEP_PIN, LOW);
//PORTF&=0b11111110;
    digitalWrite(X_STEP_PIN, HIGH); 
//PORTF|=0b00000001;
    digitalWrite(LED, HIGH); 
//PORTB|=0b10000000;
    pos[0]++;
  }
  else
  { max_x=pos[0];
    q=32;
    mov=3;
    Serial.print("max_x=");
    Serial.println(pos[0]);
  }
}
void Dec_x(void)
{ if(digitalRead(X_MIN_PIN)==0)
  { 
    
    digitalWrite(X_ENABLE_PIN, LOW);
    digitalWrite(X_DIR_PIN, HIGH);
    digitalWrite(X_STEP_PIN, LOW);
    digitalWrite(X_STEP_PIN, HIGH); 
    digitalWrite(LED, HIGH); 
    pos[0]--;
  }
  else
  { pos[0]=min_x;
    pos_set[0]=min_x;
    q=32;
    mov=3;
    Serial.print("x_pos=");
    Serial.println(pos[0]);
  }
}
void Inc_y(void)
{ 
  //if (digitalRead(Y_MAX_PIN)===0)
  if((PINJ&0b00000001)==0)
  { //digitalWrite(Y_ENABLE_PIN, LOW);
    PORTF&=0b11111011;
    //digitalWrite(Y_DIR_PIN, LOW);
    PORTF&=0b01111111;
    //digitalWrite(Y_STEP_PIN, LOW);
    PORTF&=0b10111111;
    digitalWrite(Y_STEP_PIN, HIGH); //?????????????
    //PORTF|=0b01000000;
    //PORTF|=0b01000000;
    //digitalWrite(LED, HIGH); 
    PORTB|=0b10000000;
    pos[1]++;
  }
  else
  { max_y=pos[1];
    q=32;
    mov=3;
    Serial.print("max_y=");
    Serial.println(pos[1]);
  }
}
void Dec_y(void)
{ if(digitalRead(Y_MIN_PIN)==0)
  { digitalWrite(Y_ENABLE_PIN, LOW);
    digitalWrite(Y_DIR_PIN, HIGH);
    digitalWrite(Y_STEP_PIN, LOW);
    digitalWrite(Y_STEP_PIN, HIGH); 
    digitalWrite(LED, HIGH); 
    pos[1]--;
  }
  else
  { pos[1]=min_y;
    q=32;
    mov=3;
    Serial.print("y_pos=");
    Serial.println(pos[1]);
  }
}
void Inc_z(void)
{ if (digitalRead(Z_MAX_PIN)==0)
  { digitalWrite(Z_ENABLE_PIN, LOW);
    digitalWrite(Z_DIR_PIN, LOW);
    digitalWrite(Z_STEP_PIN, LOW);
    digitalWrite(Z_STEP_PIN, HIGH); 
    digitalWrite(LED, HIGH); 
    pos[2]++;
  }
  else
  { max_z=pos[2];
    q=32;
    mov=3;
    Serial.print("max_z=");
    Serial.println(pos[2]);
  }
}
void Dec_z(void)
{ if(digitalRead(Z_MIN_PIN)==0)
  { digitalWrite(Z_ENABLE_PIN, LOW);
    digitalWrite(Z_DIR_PIN, HIGH);
    digitalWrite(Z_STEP_PIN, LOW);
    digitalWrite(Z_STEP_PIN, HIGH); 
    digitalWrite(LED, HIGH); 
    pos[2]--;
  }
  else
  { pos[2]=min_z;
    q=32;
    mov=3;
    Serial.print("z_pos=");
    Serial.println(pos[1]);
  }
}
void Inc_e(void)
{ digitalWrite(E_ENABLE_PIN, LOW);
  digitalWrite(E_DIR_PIN, LOW);
  digitalWrite(E_STEP_PIN, LOW);
  digitalWrite(E_STEP_PIN, HIGH); 
  digitalWrite(LED, HIGH); 
  pos[3]++;
}
void Dec_e(void)
{ digitalWrite(E_ENABLE_PIN, LOW);
  digitalWrite(E_DIR_PIN, HIGH);
  digitalWrite(E_STEP_PIN, LOW);
  digitalWrite(E_STEP_PIN, HIGH); 
  digitalWrite(LED, HIGH); 
  pos[3]--;
}
void Inc_q(void)
{ digitalWrite(Q_ENABLE_PIN, LOW);
  digitalWrite(Q_DIR_PIN, LOW);
  digitalWrite(Q_STEP_PIN, LOW);
  digitalWrite(Q_STEP_PIN, HIGH); 
  digitalWrite(LED, HIGH); 
  pos[4]++;
}
void Dec_q(void)
{ digitalWrite(Q_ENABLE_PIN, LOW);
  digitalWrite(Q_DIR_PIN, HIGH);
  digitalWrite(Q_STEP_PIN, LOW);
  digitalWrite(Q_STEP_PIN, HIGH); 
  digitalWrite(LED, HIGH); 
  pos[4]--;
}
void inline Stop_x(void)
//M1;1V1;1D1;1G5
{ 
  //digitalWrite(X_ENABLE_PIN, HIGH);
  //digitalWrite(LED, LOW); 
    //Stop_x
    PORTD|=0b10000000;
    PORTB&=0b01111111;
}
void Stop_y(void)
{ //digitalWrite(Y_ENABLE_PIN, HIGH);
  //digitalWrite(LED, LOW); 
  //Stop_y
  PORTF|=0b00000100;
  PORTB&=0b01111111;
}
void Stop_z(void)
{ digitalWrite(Z_ENABLE_PIN, HIGH);
  digitalWrite(LED, LOW); 
}
void Stop_e(void)
{ digitalWrite(E_ENABLE_PIN, HIGH);
  digitalWrite(LED, LOW); 
}
void Stop_q(void)
{ digitalWrite(Q_ENABLE_PIN, HIGH);
  digitalWrite(LED, LOW); 
}
//=================================

//-------SetTemperature--------//
void SetT_T1(void)
{ uint8_t t_0;
  t_0=termo[0];
  //analogWrite(8, t_0);
  if(t_0==0)        {cbi(TCCR4A, COM4C1);PORTH&=0b11011111;} 
  else if(t_0==255) {cbi(TCCR4A, COM4C1);PORTH|=0b00100000;}
  else              {sbi(TCCR4A, COM4C1);OCR4C=t_0;        }
  t_0=termo[1];
  if(t_0==0)        {cbi(TCCR2A, COM2B1);PORTH&=0b10111111;}
  else if(t_0==255) {cbi(TCCR2A, COM2B1);PORTH|=0b01000000;}
  else              {sbi(TCCR2A, COM2B1); OCR2B=t_0;       }
}
//-------Timer1Interrupt--------//
void Timer1Interrupt(void)
{
k1++;
 if(k1==5) //25000
 {  k1=0;
    flag=1;
 }
// tim1=micros();//===============
   //analogWrite(8, pos_set[5]);
   //analogWrite(9, pos_set[6]);
   //SetT_T1();
// tim2=micros();//===============
      if(mov==1)
      {   
          if(tx>0)tx--; if(ty>0)ty--; if(tz>0)tz--;
          if(te>0)te--; if(tq>0)tq--;
        {
          //q==0 =========================
          if((q==0)&&(tx==0))
          {
                error = error + deltaerr;
                error2 = error2 + deltaerr2;
                error3 = error3 + deltaerr3;
                error4 = error4 + deltaerr4;
                if(maxxyz==0)
                { if(dx==1) Inc_x();
                  if(dx==-1) Dec_x();
                  tx=txx;
                }
                else if(maxxyz==1)
                { if(dy==1)  Inc_y();
                  if(dy==-1) Dec_y();
                  tx=tyy;
                }
                else if(maxxyz==2)
                { if(dz==1)  Inc_z();
                  if(dz==-1) Dec_z();
                  tx=tzz;
                }
                else if(maxxyz==3)
                { if(de==1)  Inc_e();
                  if(de==-1) Dec_e();
                  tx=tee;
                }
                else if(maxxyz==4)
                { if(dq==1)  Inc_q();
                  if(dq==-1) Dec_q();
                  tx=tqq;
                }
                if ((2 * error) >= deltax) q|=1;
                if ((2 * error2)>= deltax) q|=2;
                if ((2 * error3)>= deltax) q|=4;
                if ((2 * error4)>= deltax) q|=8;
                if(q==0)q=16;
          }
          //q==1 =========================
          if( ((q&1)==1) && (ty==0) )
          {     error = error - deltax;
                if(maxxyz==1)
                { if(dx==1)  Inc_x();
                  if(dx==-1) Dec_x();
                  ty=txx;
                }
                else
                { if(dy==1)  Inc_y();
                  if(dy==-1) Dec_y();
                  ty=tyy;
                }
                q=q&(~1);
                if(q==0)q=16;
          }
          //q==2 =========================
          if( ((q&2)==2) && (tz==0) )
          {     error2 = error2 - deltax;
                if(maxxyz==2)
                { if(dx==1)  Inc_x();
                  if(dx==-1) Dec_x();
                  tz=txx;
                }
                else
                { if(dz==1)  Inc_z();
                  if(dz==-1) Dec_z();
                  tz=tzz;
                }
                q=q&(~2);
                if(q==0)q=16;
          }
          //q==4 =========================
          if( ((q&4)==4) && (te==0) )
          {     error3 = error3 - deltax;
                if(maxxyz==3)
                { if(dx==1)  Inc_x();
                  if(dx==-1) Dec_x();
                  te=txx;
                }
                else
                { if(de==1)  Inc_e();
                  if(de==-1) Dec_e();
                  te=tee;
                }
                q=q&(~4);
                if(q==0)q=16;
          }
          //q==8 =========================
          if( ((q&8)==8) && (tz==0) )
          {     error4 = error4 - deltax;
                if(maxxyz==4)
                { if(dx==1)  Inc_x();
                  if(dx==-1) Dec_x();
                  tq=txx;
                }
                else
                { if(dq==1)  Inc_q();
                  if(dq==-1) Dec_q();
                  tq=tqq;
                }
                q=q&(~8);
                if(q==0)q=16;
          }
          //q==16 =========================
//          if((q==16)&&(tx==0))
          if(q==16)
          {     i++;
                q=0;
                if(i>=deltax)
                { mov=2;
                  q=32;
//                Serial.print("x_pos=");
//                Serial.println(pos[0]);

                }
          }
          if(q==32)//EndGo()
          {     
                  //Stop_x();   
                  //Stop_y();
                  //Stop_z();
                  //Stop_e();
                  //Stop_q();
                  for(uint8_t i=0;i<5;i++)
                  if (go[i]==1){go[i]=2;ton[i]=ton_set[i];
                               }
                  menu_redraw_required=1;
                  comm_n=0; //===============!!!!!!!!!!
                  //tim2=tim0;
                  //Serial.print("Stop");
                  //Serial.println(tim2-tim1);
                  //tim1=tim2;
         }
        }
      }//mov==1
        //Serial.print(tim2);
        //Serial.print(" ");
        //Serial.println(tim1);
     //tim3=micros();//================  
     //tim1=tim2=tim3;//================   
      for(uint8_t i=0;i<5;i++)
      {  if(go[i]==2)
         { if(ton[i]>0)ton[i]--;
           if(ton[i]==0)
           { go[i]=0;
             if(i==0)
             {     //Stop_x
                   PORTD|=0b10000000;
                   PORTB&=0b01111111;
                   //Stop_x();
             }
             else if(i==1)Stop_y();
             else if(i==2)Stop_z();
             else if(i==3)Stop_e();
             else if(i==4)Stop_q();
             menu_redraw_required=1;
           }
         }
        
      }
      //tim4=micros();//================  
      //tim1=tim2=tim3=tim0; 
      
      t_q++;
      if(t_q==8)
      {
        if(go[0]==2)digitalWrite(X_ENABLE_PIN, HIGH); 
        if(go[1]==2)digitalWrite(Y_ENABLE_PIN, HIGH); 
        if(go[2]==2)digitalWrite(Z_ENABLE_PIN, HIGH); 
        if(go[3]==2)digitalWrite(E_ENABLE_PIN, HIGH); 
        if(go[4]==2)digitalWrite(Q_ENABLE_PIN, HIGH); 
        
      }
      
      if(t_q==10)
      { t_q=0;
        if(go[0]==2)digitalWrite(X_ENABLE_PIN, LOW); 
        if(go[1]==2)digitalWrite(Y_ENABLE_PIN, LOW); 
        if(go[2]==2)digitalWrite(Z_ENABLE_PIN, LOW); 
        if(go[3]==2)digitalWrite(E_ENABLE_PIN, LOW); 
        if(go[4]==2)digitalWrite(Q_ENABLE_PIN, LOW); 
        
      }
                 //tim5=micros();//================  
                 //tim1=tim2=tim3=tim4=tim0;  
                 {   
                 //Serial.print(tim1-tim0);
                 //Serial.print("+");
                 //Serial.print(tim2-tim1);
                 //Serial.print("+");
                 //Serial.print(tim3-tim2);
                 //Serial.print("+");
                 //Serial.print(tim4-tim3);
                 //Serial.print("+");
                 //Serial.print(tim5-tim4);
                 //Serial.print("=");
                 //Serial.println(tim5-tim0);
                 }
                 //Serial.println(tim0);
                 tim0++;//================
}//Timer1Interrupt 
//=======================================================
void loop() 
{ 
 read_command();
 //read_command1();

 { 
  xminold=xmin;xmaxold=xmax;
  yminold=ymin;ymaxold=ymax;
  zminold=zmin;zmaxold=zmax;
  xmin=digitalRead(X_MIN_PIN)+48;
  ymin=digitalRead(Y_MIN_PIN)+48;
  zmin=digitalRead(Z_MIN_PIN)+48;
  xmax=digitalRead(X_MAX_PIN)+48;
  ymax=digitalRead(Y_MAX_PIN)+48;
  zmax=digitalRead(Z_MAX_PIN)+48;
  if( (xminold!=xmin)||(yminold!=ymin)||(zminold!=zmin)||
      (xmaxold!=xmax)||(ymaxold!=ymax)||(zmaxold!=zmax) )
  {
  Serial.print("X_MIN=");  Serial.print(xmin);
  Serial.print(" Y_MIN="); Serial.print(ymin);
  Serial.print(" Z_MIN="); Serial.println(zmin);
  Serial.print("X_MAX=");  Serial.print(xmax);
  Serial.print(" Y_MAX="); Serial.print(ymax);
  Serial.print(" Z_MAX="); Serial.println(zmax);
  }
 } 

 if(flag==1)
 { flag=0;
   disp_set_position();
  /*
  qq++;
  if(qq==20)
  { qq=0;
    for(char i = 0; i< 7; i++ ) 
    pos_old[i]=pos_copy[i];
//  }
 for(char i = 0; i< 7; i++ ) 
 {
  noInterrupts();
  pos_copy[i] = pos[i];
  interrupts();
 
 if(pos_disp[i]!=pos_copy[i])
 if(    
        (pos_copy[i]==pos_old[i] )  
    ||
    (abs(pos_copy[i]-pos_disp[i])>=2000) 
    )
  {
  Serial.print(axis_name[i]);
  Serial.print("_pos=");
  Serial.println(pos_copy[i]);
  pos_disp[i]=pos_copy[i];
  menu_redraw_required = 1;
  }
 }
 }
 
  
  */
 encoderStep();                                     // check for key press

                  //===================
                  //tim2=tim0;
                  //Serial.print("menu_redraw=");
                  //Serial.println(tim2-tim1);
                  //tim1=tim2;


  if (  menu_redraw_required != 0 ) {
/*    
    

                  //===================
                  //tim2=tim0;
                  //Serial.print("StartLCD=");
                  //Serial.println(tim2-tim1);
                  //tim1=tim2;
    
    
    u8g.firstPage();
    do  {
          drawMenu();
        } while( u8g.nextPage() );
    menu_redraw_required = 0;
    
                  //===================
                  tim2=tim0;
                  Serial.print("EndLCD=");
                  Serial.println(tim2-tim1);
                  tim1=tim2;
*/    
  }
  
  updateMenu();                            // update menu bar
//===========================
  
 }//if(flag==1)  
} //loop()
       
